#include <stdlib.h>
#include "BODY.h"


// BODYNX̃[m
void New_body(BODY *Body,int TypeNum[])
{
	int flag=0;

	// GeBeBVɒǉꍇ͈ȉɐVmallocLqĂB
	// GeBeB^Cv̔ԍႢɋLq
	if(TypeNum[_CIRCLE_ARC]){
		if((Body->CirA = (CIRA *)malloc(sizeof(CIRA)*TypeNum[_CIRCLE_ARC])) == NULL)  goto EXIT;
		flag = _CIRCLE_ARC+1;
	}

	if(TypeNum[_COMPOSITE_CURVE]){
		if((Body->CompC = (COMPC *)malloc(sizeof(COMPC)*TypeNum[_COMPOSITE_CURVE])) == NULL)  goto EXIT;
		flag = _COMPOSITE_CURVE+1;
	}

	if(TypeNum[_CONIC_ARC]){
		if((Body->ConA = (CONA *)malloc(sizeof(CONA)*TypeNum[_CONIC_ARC])) == NULL)  goto EXIT;
		flag = _CONIC_ARC+1;
	}

	if(TypeNum[_LINE]){
		if((Body->Line = (LINE_ *)malloc(sizeof(LINE_)*TypeNum[_LINE])) == NULL)  goto EXIT;
		flag = _LINE+1;
	}

	if(TypeNum[_TRANSFORMATION_MATRIX]){
		if((Body->TMat = (TMAT *)malloc(sizeof(TMAT)*TypeNum[_TRANSFORMATION_MATRIX])) == NULL)  goto EXIT;
		flag = _TRANSFORMATION_MATRIX+1;
	}

	if(TypeNum[_NURBSC]){
		if((Body->NurbsC = (NURBSC *)malloc(sizeof(NURBSC)*TypeNum[_NURBSC])) == NULL)  goto EXIT;
		flag = _NURBSC+1;
	}

	if(TypeNum[_NURBSS]){
		if((Body->NurbsS = (NURBSS *)malloc(sizeof(NURBSS)*TypeNum[_NURBSS])) == NULL)  goto EXIT;
		flag = _NURBSS+1;
	}

	if(TypeNum[_CURVE_ON_PARAMETRIC_SURFACE]){
		if((Body->ConpS = (CONPS *)malloc(sizeof(CONPS)*TypeNum[_CURVE_ON_PARAMETRIC_SURFACE])) == NULL)  goto EXIT;
		flag = _CURVE_ON_PARAMETRIC_SURFACE+1;
	}

	if(TypeNum[_TRIMMED_SURFACE]){
		if((Body->TrmS = (TRMS *)malloc(sizeof(TRMS)*TypeNum[_TRIMMED_SURFACE])) == NULL)  goto EXIT;
		flag = _TRIMMED_SURFACE+1;
	}

	return;		// [𐳏Ɋm


EXIT:	// [mۂɎsꍇ́A܂ŊmۂďI
	fprintf(stderr,"ERROR: malloc BODY\n");
	while(flag){
		if(flag == _CURVE_ON_PARAMETRIC_SURFACE+1 && TypeNum[_TRIMMED_SURFACE]){
			free(Body->ConpS);
		}
		else if(flag == _NURBSS+1 && TypeNum[_NURBSS]){
			free(Body->NurbsS);
		}
		else if(flag == _NURBSC+1 && TypeNum[_NURBSC]){
			free(Body->NurbsC);
		}
		else if(flag == _TRANSFORMATION_MATRIX+1 && TypeNum[_TRANSFORMATION_MATRIX]){
			free(Body->TMat);
		}
		else if(flag == _LINE+1 && TypeNum[_LINE]){
			free(Body->Line);
		}
		else if(flag == _CONIC_ARC+1 && TypeNum[_CONIC_ARC]){
			free(Body->ConA);
		}
		else if(flag == _COMPOSITE_CURVE+1 && TypeNum[_COMPOSITE_CURVE]){
			free(Body->CompC);
		}
		else if(flag == _CIRCLE_ARC+1 && TypeNum[_CIRCLE_ARC]){
			free(Body->CirA);
		}
		flag--;
	}
	exit(ERR);
}

// BODY\SGeBeB̃J
// TypeCount[ALL_ENTITY_TYPE_NUM]:eGeBeB̐i[ꂽ
void Free_body(BODY *Body,int TypeCount[])
{
	// GeBeBVɒǉꍇ͈ȉɐVfreeǉ
	if(TypeCount[_TRIMMED_SURFACE]){
		Free_TrmS_1DArray(Body->TrmS,TypeCount[_TRIMMED_SURFACE]);
		free(Body->TrmS);
	}
	if(TypeCount[_CURVE_ON_PARAMETRIC_SURFACE]){
		free(Body->ConpS);
	}
	if(TypeCount[_NURBSS]){
		Free_NurbsS_1DArray(Body->NurbsS,TypeCount[_NURBSS]);
		free(Body->NurbsS);
	}
	if(TypeCount[_NURBSC]){
		Free_NurbsC_1DArray(Body->NurbsC,TypeCount[_NURBSC]);
		free(Body->NurbsC);
	}
	if(TypeCount[_TRANSFORMATION_MATRIX]){
		free(Body->TMat);
	}
	if(TypeCount[_LINE]){
		free(Body->Line);
	}
	if(TypeCount[_CONIC_ARC]){
		free(Body->ConA);
	}
	if(TypeCount[_COMPOSITE_CURVE]){
		Free_CompC_1DArray(Body->CompC,TypeCount[_COMPOSITE_CURVE]);
		free(Body->CompC);
	}
	if(TypeCount[_CIRCLE_ARC]){
		free(Body->CirA);
	}
}

// Ȑ̃[m
int New_CompC(COMPC *compc,int num)
{
	if((compc->DEType = (int *)malloc(sizeof(int)*num)) == NULL){
		return ERR;
	}
	
	if((compc->pDE = (COMPELEM **)malloc(sizeof(COMPELEM *)*num)) == NULL){
		free(compc->DEType);
		return ERR;
	}

	compc->N = num;

	return TRUE;
}

// Ȑz̃[
void Free_CompC_1DArray(COMPC *a,int num)
{
	for(int i=0;i<num;i++)
		Free_CompC(&a[i]);
}

// Ȑ̃[
void Free_CompC(COMPC *a)
{
	free(a->DEType);
	free(a->pDE);
}

// NurbsȐ̃[m
//   *nurb:[mۂNurbsȐւ̃|C^AK:Rg[|Cg̐AN:mbgxNg̐
int New_NurbsC(NURBSC *nurb,int K, int N)
{
	if((nurb->T = (double *)malloc(sizeof(double)*N)) == NULL)
		return ERR;
	if((nurb->W = (double *)malloc(sizeof(double)*K)) == NULL){
		free(nurb->T);
		return ERR;
	}
	if((nurb->cp = (Coord *)malloc(sizeof(Coord)*K)) == NULL){
		free(nurb->T);
		free(nurb->W);
		return ERR;
	}

	return TRUE;
}

// NURBSȐz̃[
void Free_NurbsC_1DArray(NURBSC *a,int num)
{
	for(int i=0;i<num;i++)
		Free_NurbsC(&a[i]);
}

// 1{NURBSȐ̃[
void Free_NurbsC(NURBSC *a)
{
	free(a->T);
	free(a->W);
	free(a->cp);
}

// NURBSȖʂ̃[m
//   *nurb:[mۂNurbsȖʂւ̃|C^AK[2]:u,vRg[|Cg̐AN[2]:u,vmbgxNg̐
int New_NurbsS(NURBSS *nurb,int K[2],int N[2])
{
	int errflag = 0;

	if((nurb->S = (double *)malloc(sizeof(double)*N[0])) == NULL)
		goto EXIT;
	errflag++;	// 1
	if((nurb->T = (double *)malloc(sizeof(double)*N[1])) == NULL)
		goto EXIT;
	errflag++;	// 2
	if((nurb->W = NewMatrix(K[0],K[1])) == NULL)
		goto EXIT;
	errflag++; // 3
	if((nurb->cp = NewCoord(K[0],K[1])) == NULL)
		goto EXIT;

	return TRUE;

EXIT:
	if(errflag == 3){
		FreeMatrix(nurb->W);
		errflag--;
	}
	if(errflag == 2){
		free(nurb->T);
		errflag--;
	}
	if(errflag == 1){
		free(nurb->S);
	}

	return ERR;
}

// NURBSȖʔz̃[
void Free_NurbsS_1DArray(NURBSS *a,int num)
{
	for(int i=0;i<num;i++)
		Free_NurbsS(&a[i]);
}

// NURBSȖʂ̃[
void Free_NurbsS(NURBSS *a)
{
	free(a->S);
	free(a->T);
	FreeMatrix(a->W);
	FreeCoord(a->cp);
}

// gʂ̃[m
int New_TrmS(TRMS *trms,int num)
{
	if((trms->pTI = (CONPS **)malloc(sizeof(CONPS *)*num)) == NULL){
		return ERR;
	}

	return TRUE;
}

// gʔz̃[
void Free_TrmS_1DArray(TRMS *a,int num)
{
	for(int i=0;i<num;i++)
		Free_TrmS(&a[i]);
}

// gʂ̃[
void Free_TrmS(TRMS *a)
{
	free(a->pTI);
}

// GeBeB̃Xe[^XŒ`ĂFύX
void ChangeStatColor(float *col,float r,float g,float b,float t)
{
	col[0] = r;
	col[1] = g;
	col[2] = b;
	col[3] = t;
}

// bodyXg̎̃f[^ֈړ
BODY *ShiftBodyList(BODY *body)
{
	return(body->next);
}

// bodyXg1[mۂ
BODY *AllocBodyList()
{
	return((BODY *)malloc(sizeof(BODY)));

}

// bodyXg̎w肵ʒuɐVbody}
//    **body:BODYXg̐擪AhX  key:Vɑ}ꏊ1OBODYԍ  new_body:Vɑ}BODY
void AddBodyList(BODY **body,int key,BODY *new_body)
{
	BODY *Curr;		// ڒBODYw

	// 1ڂBODY̏ꍇ
	if(key < 0){
		*body = new_body;		// BODYXg̐擪ɐVBODYǉ
		(*body)->next = NULL;	// ̗vfNULLɂ
		return;
	}
	// 2ڈȍ~̏ꍇ
	else{
		Curr = *body;							// BODYXg̐擪Ɉړ
		while(Curr != NULL){					// Xg̃Gh܂Ń[v
			if(Curr->key == key){				// VBODY}ꏊ̒OBODY𔭌
				new_body->next = Curr->next;	// Xg̍q
				Curr->next = new_body;			// Xg̍q
				return;
			}
			Curr = ShiftBodyList(Curr);			// BODYֈړ
		}
	}
}

// w肵bodyԍbodyXg폜
//   **body:BODYXg̐擪AhX  key:폜BODYvfԍ
void DelBodyList(BODY **body,int key)
{
	BODY *pre;
	BODY *Curr;
	
	pre = Curr = *body;

	while(Curr != NULL){
		if(Curr->key == key){
			Free_body(Curr,Curr->TypeNum);	// bodỹ[
			if(Curr == *body)
				*body = Curr->next;
			else
				pre->next = Curr->next;
			free(Curr);						// ŌɎ
			return;
		}
		pre = Curr;
		Curr = ShiftBodyList(Curr);
	}
}

// w肵Bodyԍ(key)̈ʒu. ȂꍇNULLԂ
BODY *SearchBodyList(BODY *body,int key)
{
	BODY *Curr;

	Curr = body;
	while(Curr != NULL){
		if(Curr->key == key){
			return Curr;
		}
		Curr = ShiftBodyList(Curr);
	}

	return NULL;
}
