// OpenGL UserInterface

#include "Describe.h"

// DESCRIBENXŗpX^eBbNϐ
BODY *DESCRIBE::glbody;					// IGESf[^Xg̐擪AhX
BODY *DESCRIBE::Curr_body;				// IGESf[^Xg̒ڒ̃AhXi[
IGES_PARSER DESCRIBE::Parser;			// IGESp[T[pIuWFNg𐶐
QUATERNION DESCRIBE::QFunc;				// NH[^jIZCuNX
NURBS_Func DESCRIBE::NFunc;				// NURBS_FuncNX̃IuWFNg𐶐
USER DESCRIBE::User;					// UserNX̃IuWFNg𐶐
int  DESCRIBE::ScreenHeight;			// `EBhE̍
int  DESCRIBE::ScreenWidth;				// `EBhE̕
int  DESCRIBE::StartX;					// hbOJnʒuX
int  DESCRIBE::StartY;					// hbOJnʒuY
int  DESCRIBE::OldPosX;					// EBhEĕ`撼OXW
int  DESCRIBE::OldPosY;					// EBhEĕ`撼OYW
int  DESCRIBE::CurrentX;				// hbÖʒuX
int  DESCRIBE::CurrentY;				// hbÖʒuY
int  DESCRIBE::SweepSelectFlag;			// XC[vZNVJnƂtO
int  DESCRIBE::Vp[4];					// r[|Cg
GLuint  DESCRIBE::SelectBuf[MAXSELECT]; // ZNgobt@
int  DESCRIBE::LBtnFlag;				// NbNƂtO
int  DESCRIBE::RBtnFlag;				// ENbNƂtO
int  DESCRIBE::MBtnFlag;				// NbNƂtO
int  DESCRIBE::ShiftKeyFlag;			// ShiftL[ƂtO
int  DESCRIBE::CtrlKeyFlag;				// CtrlL[ƂtO
int  DESCRIBE::AltKeyFlag;				// AltL[ƂtO
Quat DESCRIBE::StartQ;					// ENbNuԂ̉]pi[NH[^jI
Quat DESCRIBE::TargetQ;					// 肮Ăr̃NH[^jI
double DESCRIBE::RotMx[TMATELEMNUM];	// NH[^jIϊ}gbNX
double DESCRIBE::Trl[3];				// sړ
double DESCRIBE::AxisScale;				// ̃XP[
double DESCRIBE::ModelScale;			// f̃XP[
double DESCRIBE::ModelScale1st;			// fXP[̏l
double DESCRIBE::IdentX;				// }EX̐ΈʒuXEBhEł̑ΈʒůZWX
double DESCRIBE::IdentY;				// }EX̐ΈʒuYEBhEł̑ΈʒůZWY
int DESCRIBE::DrawSurfFlagCount;		// Surface`tOj[Iꂽ𐔂JE^
int DESCRIBE::DrawBODYFlagCount;		// BODY`tOj[Iꂽ𐔂JE^
int DESCRIBE::DrawUserFuncFlag;			// PDT`tO
OBJECT DESCRIBE::SelectedEntList[MAXSELECT];// ZNVꂽGeBeB𒀎i[Ă
int DESCRIBE::PickCount;				// sbN񐔂JEg
int DESCRIBE::SPickCount;				// NURBSȖʂsbNꂽJEg
int DESCRIBE::CPickCount;				// NURBSȐsbNꂽJEg
int DESCRIBE::BodyCount;				// body̐JEg


// DESCRIBENX̃RXgN^
DESCRIBE::DESCRIBE()
{
	// 
	LBtnFlag = GL_FALSE;
	RBtnFlag = GL_FALSE;
	MBtnFlag = GL_FALSE;
	ShiftKeyFlag = GL_FALSE;
	CtrlKeyFlag = GL_FALSE;
	AltKeyFlag = GL_FALSE;
	SweepSelectFlag = GL_FALSE;
	StartX = 0;
	StartY = 0;
	OldPosX = 0;
	OldPosY = 0;
	CurrentX = 0;
	CurrentY = 0;
	ScreenHeight = 240;
	ScreenWidth = 320;
	AxisScale = 0.2;
	ModelScale = 1;
	StartQ = QFunc.QInit(1.0,0.0,0.0,0.0);
	TargetQ = QFunc.QInit(1.0,0.0,0.0,0.0);
	Vp[0] = Vp[1] = Vp[2] = Vp[3] = 0;
	Trl[0] = Trl[1] = Trl[2] = 0.0;
	DrawBODYFlag = TRUE;
	DrawSurfFlag = TRUE;
	DrawBODY1st = FALSE;
	DrawSurfFlagCount = 0;
	DrawBODYFlagCount = 0;
	DrawUserFuncFlag = FALSE;
	PickCount = 0;
	CPickCount = 0;
	SPickCount = 0;
	BodyCount = 0;
}

// DESCRIBENX̃fXgN^iglutCxg[v𔲂ƕKĂ΂j
DESCRIBE::~DESCRIBE()
{
	Curr_body = glbody;
	for(int i=0;i<BodyCount;i++){
		DelBodyList(&glbody,i);
	}
}

// OpenGL`
int DESCRIBE::BODY_Describe_Main(int argc,char *argv[])
{
	int sub_menu_ID1,sub_menu_ID2;
	char YorN = 'y';
	char buf[256];

	// IGESt@Cǂݍ
	glbody = NULL;
	while(YorN=='y' || YorN=='Y'){
		if(GenBodyList() == ERR)		// IGESǂݍ݁ABODYNX̃Xg`
			return ERR;
		fprintf(stderr,"Inport new IGES file? ('y' or 'n'):");
		fgets(buf,sizeof(buf),stdin);
		sscanf(buf,"%c",&YorN);
	}
	fprintf(stderr,"IGESt@CǂݍݏI\n");

	//fprintf(stderr,"MaxCoord = %lf\n",glbody->MaxCoord); 
	ModelScale = ModelScale/glbody->MaxCoord;			// ʂɃIuWFNgŜʂ悤ɒ
	ModelScale1st = ModelScale;

	glutInit(&argc, argv);								// OpenGL
	Init("KODATUNO");									// OtBbNݒ(EBhEn)
	glutKeyboardFunc(Keyboard);							// L[Cxg̐ݒ
	glutSpecialFunc(Special);							// L[Cxg̐ݒ
	glutMouseFunc(Mouse);								// }EXCxg̐ݒ
	glutMotionFunc(Motion);								// }EX[VCxg̐ݒ
	glutReshapeFunc(Reshape);							// ĕ`Cxg̐ݒ
	glutDisplayFunc(Display);							// `RA(BODY`悳)

	sub_menu_ID1 = glutCreateMenu(Sub_Menu_View);		// _؊pj[o^
	glutAddMenuEntry("View on x-axis",S_M_XView);		// _؊pj[Tuj[
	glutAddMenuEntry("View on y-axis",S_M_YView);		// _؊pj[Tuj[
	glutAddMenuEntry("View on z-axis",S_M_ZView);		// _؊pj[Tuj[
	sub_menu_ID2 = glutCreateMenu(Sub_Menu_User);		// User֐o^(C1+Tu5)
	glutAddMenuEntry(User.MenuLabelMain,M_Label_Main);	// UserC֐
	glutAddMenuEntry(User.MenuLabel1,M_Label1);			// UserTu֐1
	glutAddMenuEntry(User.MenuLabel2,M_Label2);			// UserTu֐2
	glutAddMenuEntry(User.MenuLabel3,M_Label3);			// UserTu֐3
	glutAddMenuEntry(User.MenuLabel4,M_Label4);			// UserTu֐4
	glutAddMenuEntry(User.MenuLabel5,M_Label5);			// UserTu֐5
	glutCreateMenu(Menu);								// Cj[Cxg̐ݒ
	glutAddSubMenu("Execute User Function",sub_menu_ID2);	// j[o^(User֐)
	glutAddMenuEntry("Selection Cancel",M_UnSelect);		// j[o^(PDT`)
	glutAddMenuEntry("Draw BODY ON/OFF",M_Draw_Body);		// j[o^(BODY` ON/OFF؊)
	glutAddMenuEntry("Draw Surface ON/OFF",M_Draw_Surf);	// j[o^(Surface` ON/OFF؊)
	glutAddSubMenu("View Angle",sub_menu_ID1);				// j[o^(_؊)
	glutAddMenuEntry("Version info",M_Version);				// j[o^(o[W)
	glutAttachMenu(GLUT_RIGHT_BUTTON);						// E{^Ƀj[zu

	glutMainLoop();											// Cxg҂[v

	// Cxg[v𔲂ƁAKODatuno::~KODatUNOĂ΂

	return TRUE;
}

// Cj[̃Cxgo^
void DESCRIBE::Menu(int val)
{
	switch(val){
		// o[W
		case M_Version:
			VersionInfo();
			break;

		// ZNV
		case M_UnSelect:
			for(int i=0;i<PickCount;i++){		// Fɖ߂
				Curr_body = glbody;							
				Curr_body = SearchBodyList(Curr_body,SelectedEntList[i].Body);						// ǂBODYIĂ邩ׂ
				if(SelectedEntList[i].Type == _NURBSC){
					ChangeStatColor(Curr_body->NurbsC[SelectedEntList[i].Num].Dstat.Color,1,1,1,1);	// Iς݂ߐFύX
				}
				else if(SelectedEntList[i].Type == _TRIMMED_SURFACE){
					ChangeStatColor(Curr_body->NurbsS[SelectedEntList[i].Num].Dstat.Color,0.2,0.2,0.2,1);	// Iς݂ߐFύX
				}
			}
			PickCount = 0;				// ZNV0ɏ
			DrawUserFuncFlag = FALSE;	// User֐sς݃tOOFF
			UpDateDisplayList(TRUE);	// `IuWFNg̕ύXXV
			break;

		// Surface`ON/OFF
		case M_Draw_Surf:
			DrawSurfFlagCount = 1 - DrawSurfFlagCount;
			if(DrawSurfFlagCount)
				gluNurbsProperty(NurbsSurf, GLU_DISPLAY_MODE, GLU_OUTLINE_PATCH);
			else
				gluNurbsProperty(NurbsSurf, GLU_DISPLAY_MODE, GLU_FILL);
			UpDateDisplayList(FALSE);
			break;

		// BODY`ON/OFF	
		case M_Draw_Body:
			DrawBODYFlagCount = 1 - DrawBODYFlagCount;
			if(DrawBODYFlagCount)
				DrawBODYFlag = FALSE;
			else
				DrawBODYFlag = TRUE;
			break;
	}

	glutPostRedisplay();
}


// User֐menuɓo^
void DESCRIBE::Sub_Menu_User(int val)
{
	switch(val){
		// UserC֐
		case M_Label_Main:
			if(PickCount){
				AddEntSymbolToObj();								// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
				glNewList(COMMAND_DRAW_USER,GL_COMPILE);			// User֐łUserC֐ł̏̂ݕ`捂{
				User.UserFuncMain(glbody,SelectedEntList,PickCount);// UserC֐s
				glEndList();
				DrawUserFuncFlag = TRUE;							// UserC֐sς݃tOON
			}
			break;

		// UserTu֐1
		case M_Label1:
			AddEntSymbolToObj();								// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
			User.UserFunc1(glbody,SelectedEntList,PickCount);	// UserTu֐1s
			break;

		// UserTu֐2
		case M_Label2:
			AddEntSymbolToObj();								// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
			User.UserFunc2(glbody,SelectedEntList,PickCount);	// UserTu֐1s
			break;

		// UserTu֐3
		case M_Label3:
			AddEntSymbolToObj();								// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
			User.UserFunc3(glbody,SelectedEntList,PickCount);	// UserTu֐1s
			break;

		// UserTu֐4
		case M_Label4:
			AddEntSymbolToObj();								// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
			User.UserFunc4(glbody,SelectedEntList,PickCount);	// UserTu֐1s
			break;

		// UserTu֐5
		case M_Label5:
			AddEntSymbolToObj();								// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
			User.UserFunc5(glbody,SelectedEntList,PickCount);	// UserTu֐1s
			break;
	}
	glutPostRedisplay();
}

// _؊
void DESCRIBE::Sub_Menu_View(int val)
{
	switch(val){
		// X-View
		case S_M_XView:
			StartQ = QFunc.QInit(1,0,0,0);		// ̉]p
			QFunc.QtoR(RotMx,StartQ);			// ̉]p
			TargetQ = QFunc.QMult(QFunc.QGenRot(PI/2,0,0,1), StartQ);	// NH[^jIŏʒuɑ΂Z90]
			QFunc.QtoR(RotMx,TargetQ);			// ]sɑ
			StartQ = QFunc.QCopy(TargetQ);
			ModelScale = ModelScale1st;			// XP[
			Trl[0] = Trl[1] = Trl[2] = 0;		// sړʏ
			break;
		// Y-View
		case S_M_YView:
			StartQ = QFunc.QInit(1,0,0,0);
			QFunc.QtoR(RotMx,StartQ);
			ModelScale = ModelScale1st;
			Trl[0] = Trl[1] = Trl[2] = 0;
			break;
		// Z-View
		case S_M_ZView:
			StartQ = QFunc.QInit(1,0,0,0);
			QFunc.QtoR(RotMx,StartQ);
			TargetQ = QFunc.QMult(QFunc.QGenRot(PI/2,1,0,0), StartQ);	// NH[^jIŏʒuɑ΂X90]
			QFunc.QtoR(RotMx,TargetQ);	
			StartQ = QFunc.QCopy(TargetQ);
			ModelScale = ModelScale1st;
			Trl[0] = Trl[1] = Trl[2] = 0;
			break;
	}
	glutPostRedisplay();
}

// IGES`RA
void DESCRIBE::Display()
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);						// fr[s

	glLoadIdentity();								// fr[s̐擪ɒPʍs}

	gluLookAt(0,1,0.0,0.0,0.0,0.0,0.0,0.0,1.0);		// _ݒ

	glScaled(ModelScale,ModelScale,ModelScale);		// fXP[ݒ

	glTranslatef(Trl[0],Trl[1],Trl[2]);				// Wn𕽍sړ
	
	glMultMatrixd(RotMx);							// fr[sɕύXꂽ]sĂ

	glDrawAxis(AxisScale,ModelScale);				// W`

	// BODY`tOONȂ`
	if(DrawBODYFlag == TRUE){
		if(DrawBODY1st == FALSE){									// ԏ̂݃fBXvCXgBODYo^
			glNewList(COMMAND_DRAW_BODY,GL_COMPILE_AND_EXECUTE);	// glDrawBODY()R}hƂă[ɕۑ(ZNV̍)
			glDrawBODY();											// IGESf[^`
			glEndList();
			DrawBODY1st = TRUE;
		}
		else{
			glCallList(COMMAND_DRAW_BODY);			// 2ڈȍ~̕`Ăяo̓fBXvCXgĂяo
		}
	}

	// UserFuncɂĐꂽ`w߂s
	if(DrawUserFuncFlag == TRUE)
		glCallList(COMMAND_DRAW_USER);

	// XC[vZNVtOONȂ`
	if(SweepSelectFlag == GL_TRUE){
		glMatrixMode(GL_PROJECTION);				// eϊsX^bNI
		glPushMatrix();								// ݂̍Wnۑ
		glLoadIdentity();							// eϊsX^bN̐擪ɒPʍs}
		gluOrtho2D(0,ScreenWidth,ScreenHeight,0); 	// _ݒ(o[oh𐳂ʒuɕ\邽)

		glMatrixMode(GL_MODELVIEW);					// fr[s
		glPushMatrix();								// ݂̍Wnۑ
		glLoadIdentity();							// fr[s̐擪ɒPʍs}
		
		glDrawRubberband(StartX,StartY,CurrentX,CurrentY);		// o[oh`

		// Wnɖ߂
		glMatrixMode(GL_MODELVIEW);
		glPopMatrix();
		glMatrixMode(GL_PROJECTION);
		glPopMatrix();
	}

	glutSwapBuffers();
}

// EChE̍č쐬
void DESCRIBE::Reshape(int width, int height)
{
	double ratio;
	double a=2;

	ScreenWidth = width;			// ύXꂽXN[̕𓾂
	ScreenHeight = height;			// ύXꂽXN[̍𓾂

	glViewport(0,0,width,height);

	glMatrixMode(GL_PROJECTION);	// eϊsX^bNI
	glLoadIdentity();				// eϊsX^bN̐擪ɒPʍs}

	// seݒ(AXyNgɂăf̏c䂪ςȂ悤ɏ𕪂)
	if(width <= height){
		ratio = (double)height/(double)width;
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}
	else{
		ratio = (double)width/(double)height;
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}

	glMatrixMode(GL_MODELVIEW);		// fr[sX^bNI
}

// OtBbN̏ݒ
void DESCRIBE::Init(char *progname)
{
	GLfloat diffuse[] = { 0.9, 0.9, 0.9, 1.0 };
	GLfloat specular[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat ambient[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat mat_diffuse[] = { 0.7, 0.7, 0.7, 1.0 };
	GLfloat mat_specular[] = { 1.0, 1.0, 1.0, 1.0 };
	GLfloat mat_shininess[] = { 100.0 };
	GLfloat mat_ambient[] = { 0.2, 0.2, 0.2, 1.0 };

	glutInitDisplayMode( GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH );
	glutInitWindowSize(ScreenWidth, ScreenHeight);		// EBhETCY
	glutInitWindowPosition(100, 100);					// EBhEʒu
	glutCreateWindow(progname);							// EBhE
	glClearColor( 0.0, 0.0, 0.0, 1.0 );					// wiF

	// ̐ݒ
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient);

	// }eA̐ݒ
	glMaterialfv(GL_FRONT, GL_DIFFUSE, mat_diffuse);
	glMaterialfv(GL_FRONT, GL_SPECULAR, mat_specular);
	glMaterialfv(GL_FRONT, GL_SHININESS, mat_shininess);
	glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, mat_ambient);

	glEnable(GL_LIGHTING);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, GL_TRUE);
	glEnable(GL_LIGHT0);
	glDepthFunc(GL_LESS);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_AUTO_NORMAL);
	glEnable(GL_NORMALIZE);
	glEnable(GL_POINT_SMOOTH);
	glEnable(GL_LINE_SMOOTH);
	glEnable(GL_POLYGON_SMOOTH);

	SetNurbsStat();

	QFunc.QtoR(RotMx,StartQ);		// ]s̏
}

// L[Cxg̐ݒ
void DESCRIBE::Keyboard(unsigned char key, int x, int y)
{
	if(key == 27){		// ESCL[ŏI
		exit(0);
	}
}

// ZNV(}EXsbLO)̐ݒ
void DESCRIBE::DoSelect(int x,int y)
{
	int hits;
	double ratio;
	double a=2;

	glGetIntegerv(GL_VIEWPORT,Vp);
	glSelectBuffer(MAXSELECT, SelectBuf);	// ZNVꂽIuWFNg̏Ăobt@p
	glRenderMode(GL_SELECT);				// ZNV[hɈڍs
	glInitNames();							// IuWFNgɂ閼O(l)o^Ăl[X^bN

	glMatrixMode(GL_PROJECTION);			// ˉeϊ[h
	glPushMatrix();							// ܂ł̕ϊ}gbNXۑ
	glLoadIdentity();						// ˉeϊ}gbNX

	// ʏ̃ZNV̏ꍇ
	if(StartX == x && StartY == y){
		gluPickMatrix((GLdouble)x,(GLdouble)(Vp[3] - y),5.0,5.0,Vp);	// \̈悪}EX|C^̎͂ɂȂ悤Ɏˉeϊsݒ
	}
	// XC[vZNV̏ꍇ
	else{
		gluPickMatrix((GLdouble)((StartX+x)/2),(GLdouble)((Vp[3]*2-y-StartY)/2),fabs((double)(x-StartX)),fabs((double)(StartY-y)),Vp);	// \̈悪o[ohɂȂ悤Ɏˉeϊsݒ
	}

	if(Vp[2] <= Vp[3]){
		ratio = (double)Vp[3]/(double)Vp[2];
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}
	else{
		ratio = (double)Vp[2]/(double)Vp[3];
		glOrtho(-a*ratio,a*ratio,-a,a,-100000,100000);
	}

	glMatrixMode(GL_MODELVIEW);					// fϊ[hɈڍs
	glLoadIdentity();							// fr[s̐擪ɒPʍs}
	gluLookAt(0,1,0.0,0.0,0.0,0.0,0.0,0.0,1.0);	// _ݒ
	glScaled(ModelScale,ModelScale,ModelScale);	// fXP[ݒ
	glTranslatef(Trl[0],Trl[1],Trl[2]);			// Wn𕽍sړ
	glMultMatrixd(RotMx);						// fr[sɕύXꂽ]sĂ
	if(DrawBODYFlag == TRUE)					// BODY`tOONȂ
		glCallList(COMMAND_DRAW_BODY);			// eGeBeBŊKwꂽZNVpԍ𓾂(炩ߓo^ĂR}hs)
	glMatrixMode(GL_PROJECTION);				// ˉeϊ[hɖ߂
	glPopMatrix();								// ˉeϊ}gNXɖ߂
	hits = glRenderMode(GL_RENDER);				// ZNV[hIA_O[hɖ߂

	if(StartX == x && StartY == y)				// NbNőIꍇ
		ClickPicking(SelectBuf,hits);
	else
		DragPicking(SelectBuf,hits);			// hbOőIꍇ

	glutPostRedisplay();
}

// NbNɂ}EXsbLO
void DESCRIBE::ClickPicking(GLuint SelectBuf[],int hits)
{
	int i;
	int objnum=0;

	objnum = ObjSelect(SelectBuf,hits);			// qbgIuWFNg̒ŃfvXl̈ԏIuWFNgI

	// ȑOɃZNgꂽ̂ăZNgꍇ̓JEgȂ
	for(i=0;i<PickCount;i++){
		if(SelectedEntList[i].Body == SelectBuf[objnum*(3+SelectBuf[0])+3] &&
			SelectedEntList[i].Type == SelectBuf[objnum*(3+SelectBuf[0])+4] &&
			SelectedEntList[i].Num == SelectBuf[objnum*(3+SelectBuf[0])+5]){
				hits = 0;
		}
	}
	
	// VIuWFNgɃqbgꍇ
	if(hits >= 1){
		SelectedEntList[PickCount].Body = SelectBuf[objnum*(3+SelectBuf[0])+3];	// ZNgꂽBODY
		SelectedEntList[PickCount].Type = SelectBuf[objnum*(3+SelectBuf[0])+4];	// ZNgꂽGeBeB^Cv
		SelectedEntList[PickCount].Num = SelectBuf[objnum*(3+SelectBuf[0])+5];	// ZNgꂽGeBeB^Cvɂ鎯ʔԍ
		BODY *Curr = glbody;
		while(Curr != NULL){
			if(SelectedEntList[PickCount].Body == Curr->key && SelectedEntList[PickCount].Type == _NURBSC){
				ChangeStatColor(Curr->NurbsC[SelectedEntList[PickCount].Num].Dstat.Color,1,0.2,1,1);	// Iς݂ߐFύX
			}
			else if(SelectedEntList[PickCount].Body == Curr->key && SelectedEntList[PickCount].Type == _TRIMMED_SURFACE){
				ChangeStatColor(Curr->NurbsS[SelectedEntList[PickCount].Num].Dstat.Color,1,1,0.2,1);	// Iς݂ߐFύX
			}
			Curr = ShiftBodyList(Curr);
		}
		PickCount++;
		UpDateDisplayList(FALSE);
	}
}

// hbOɂ}EXsbLO
void DESCRIBE::DragPicking(GLuint SelectBuf[],int hits)
{
	int i,j;
	int temp=0;	// ăZNgʗpJE^

	// ͈͑IɂăIuWFNgɃqbgꍇ
	for(i=0;i<hits;i++){
		for(j=0;j<PickCount;j++){
			if(SelectedEntList[i].Body == SelectBuf[j*(3+SelectBuf[0])+3] &&
				SelectedEntList[i].Type == SelectBuf[j*(3+SelectBuf[0])+4] &&
				SelectedEntList[i].Num == SelectBuf[j*(3+SelectBuf[0])+5]){
					temp++;
			}
		}
		// IuWFNgVqbgꍇ
		if(temp == 0){
			SelectedEntList[PickCount].Body = SelectBuf[i*(3+SelectBuf[0])+3];	// ZNgꂽBODY
			SelectedEntList[PickCount].Type = SelectBuf[i*(3+SelectBuf[0])+4];	// ZNgꂽGeBeB^Cv
			SelectedEntList[PickCount].Num = SelectBuf[i*(3+SelectBuf[0])+5];	// ZNgꂽGeBeB^Cvɂ鎯ʔԍ
			BODY *Curr = glbody;
			while(Curr != NULL){
				if(SelectedEntList[PickCount].Body == Curr->key && SelectedEntList[PickCount].Type == _NURBSC){
					ChangeStatColor(Curr->NurbsC[SelectedEntList[PickCount].Num].Dstat.Color,1,0.2,1,1);	// Iς݂ߐFύX
				}
				else if(SelectedEntList[PickCount].Body == Curr->key && SelectedEntList[PickCount].Type == _TRIMMED_SURFACE){
					ChangeStatColor(Curr->NurbsS[SelectedEntList[PickCount].Num].Dstat.Color,1,1,0.2,1);	// Iς݂ߐFύX
				}
				Curr = ShiftBodyList(Curr);
			}
			PickCount++;
		}
		temp = 0;
	}
	UpDateDisplayList(FALSE);
}

// IuWFNg̑I𔻕
int DESCRIBE::ObjSelect(GLuint SelectBuf[],int hits)
{
	int i;
	int ZdepthMin=0;
	double Zdepth[MAXSELECT];
	double depthbuf[MAXSELECT];
	double temp=0;

	// qbgSẴIuWFNg̃fvXl𓾂
	for(i=0;i<hits;i++){
		Zdepth[i] = ((((double)SelectBuf[i*(3+SelectBuf[0])+1]/0xFFFFFFFF)+((double)SelectBuf[i*(3+SelectBuf[0])+2]/0xFFFFFFFF))/2.0);	// fvXobt@̍őlƍŏl̒Ԃ̒l
		depthbuf[i] = Zdepth[i];				// fvXl̃\[gp̃obt@p
	}
	
	// qbgIuWFNg̒ŃfvXlŏ̂̂߂
	if(hits == 1)
		ZdepthMin = 0;
	else if(hits > 1)
		BubbleSort(depthbuf,hits);		// ou\[gɂfvXlŏ̂̂𓾂
	
	// fvXlŏ̂̂ꍇAʂDIɑI
	for(i=0;i<hits;i++){
		if(Zdepth[i] == depthbuf[0] && SelectBuf[i*(3+SelectBuf[0])+4] == _NURBSC){
			ZdepthMin = i;
			temp++;
			break;
		}
	}
	
	// qbgɐȂꍇ
	if(temp == 0){
		for(i=0;i<hits;i++){
			if(Zdepth[i] == depthbuf[0])
				ZdepthMin = i;
		}
	}

	return ZdepthMin;
}

// L[Cxg̐ݒ
void DESCRIBE::Special(int key,int x,int y)
{
	switch(key){
		case GLUT_KEY_UP:
			ModelScale += 0.2*ModelScale;	// g
			break;
		case GLUT_KEY_DOWN:
			ModelScale -= 0.2*ModelScale;	// k
			break;
		default:
			break;
	}
	StartX = x;
	StartY = y;
	glutPostRedisplay();
}

// }EXNbNCxg̐ݒ
void DESCRIBE::Mouse(int button,int state,int x,int y)
{
	int GetModif = glutGetModifiers();		// Shift,Ctrl,AltL[̎擾

	// NbN
	if(button == GLUT_MIDDLE_BUTTON && state == GLUT_DOWN){
		StartX = x;
		StartY = y;
		MBtnFlag = GL_TRUE;
		if(GetModif == GLUT_ACTIVE_SHIFT){		// Sift
			OldPosX = x;
			OldPosY = y;
			ShiftKeyFlag = GL_TRUE;
		}
		if(GetModif == GLUT_ACTIVE_CTRL){		// Ctrl
			OldPosX = x;
			OldPosY = y;
			CtrlKeyFlag = GL_TRUE;
		}
	}
	// NbN
	else if(button == GLUT_LEFT_BUTTON && state == GLUT_DOWN){
		StartX = x;
		StartY = y;
		LBtnFlag = GL_TRUE;
	}
	// {^𗣂
	else{
		if(MBtnFlag == GL_TRUE){
			StartQ = QFunc.QCopy(TargetQ);
		}
		if(LBtnFlag == GL_TRUE){
			DoSelect(x,y);		// IuWFNgI𔻕
		}
		SweepSelectFlag = GL_FALSE;
		LBtnFlag = GL_FALSE;
		MBtnFlag = GL_FALSE;
		ShiftKeyFlag = GL_FALSE;
		CtrlKeyFlag = GL_FALSE;
	}

	glutPostRedisplay();
}

// }EXړƂɌĂяoR[obN̐ݒ
void DESCRIBE::Motion(int x,int y)
{
	double dx,dy;				// Pʉꂽ}EXړ
	double dox,doy;				// PʉꂽEBhEĕ`撼Õ}EXړ
	double a;					// }EXړ
	double ar;					// ]p
	Quat dq;					// ]NH[^jI
	Coord axis;					// ]

	// hbO
	if(LBtnFlag == GL_TRUE){
		SweepSelectFlag = GL_TRUE;		// XB[vZNVON
		CurrentX = x;
		CurrentY = y;
	}

	// ^񒆃hbO
	if(MBtnFlag == GL_TRUE){
		// }EX|C^̈ʒũhbOJnʒu̕ψ
		dx = (double)(x-StartX)/(double)ScreenWidth;
		dy = (double)(y-StartY)/(double)ScreenHeight;
		// }EX|C^̈ʒũEBhEĕ`撼O̕ψ
		dox = (double)(x-OldPosX)/(double)ScreenWidth;
		doy = (double)(y-OldPosY)/(double)ScreenHeight;

		// Shift,CtrlL[ĂȂ-->f]
		if(ShiftKeyFlag == GL_FALSE && CtrlKeyFlag == GL_FALSE){
			a = sqrt(dx*dx + dy*dy);	// }EX|C^̈ʒũhbOJnʒű
			if(a != 0.0){
				ar = 2*PI*a;			// ]pZo
				// ]axis߂
				axis.x = dx/a;
				axis.y = 0.0;
				axis.z = -dy/a;
				dq = QFunc.QGenRot(ar,axis.z,axis.y,axis.x);	// ]NH[^jI
				TargetQ = QFunc.QMult(dq, StartQ);				// ]̏lStartQdq|ĉ]
				QFunc.QtoR(RotMx, TargetQ);						// NH[^jI]̕ϊs߂
			}
		}

		// ShiftL[Ă-->sړ
		else if(ShiftKeyFlag == GL_TRUE){
			Trl[0] -= 4*dox/ModelScale;							// }EXE֓獶E֕sړ
			Trl[2] -= 4*doy/ModelScale;							// }EX㉺֓㉺֕sړ
		}

		// CtrlL[Ă-->gk
		else if(CtrlKeyFlag == GL_TRUE){
			a = sqrt(dox*dox + doy*doy);
			if(x-OldPosX > 0)	ModelScale += a*ModelScale;		// }EXE֓g
			else				ModelScale -= a*ModelScale;		// }EX֓k
			if(ModelScale < 0.0001) ModelScale = 0.0001;		// kXP[̍ŏl
		}			

		OldPosX = x;
		OldPosY = y;
	}

	glutPostRedisplay();
}

// bodyǂݍ݃Xgɓo^
int DESCRIBE::GenBodyList()
{
	BODY *new_body;

	new_body = AllocBodyList();					// bodyV1[m

	if(Parser.IGES_Parser_Main(new_body) == ERR){		// IGESf[^̓ǂݍ
		return ERR;
	}

	CheckDegenracy(new_body);					// k(2DpgbNȐ̎n_ƏI_vĂ邩)̃`FbN

	new_body->key = BodyCount;					// ݂bodyԍ𓾂
	
	AddBodyList(&glbody,BodyCount-1,new_body);	// ǂݍbodyXg̍ŌɌq

	BodyCount++;

	return TRUE;
}



// OBJECT\̂ɉԖڂ̋ȐorȖʂ̏t
void DESCRIBE::AddEntSymbolToObj()
{
	int Cnum = 0;
	int Snum = 0;

	for(int i=0;i<PickCount;i++){
		if(SelectedEntList[i].Type == _NURBSC){
			SelectedEntList[i].CCount = Cnum;
			Cnum++;
		}
		else if(SelectedEntList[i].Type == _TRIMMED_SURFACE){
			SelectedEntList[i].SCount = Snum;
			Snum++;
		}
		else{
			fprintf(stderr,"DESCRIBE ERROR:T|[gÕGeBeBo܂\n");
		}
	}
}

// AChȌ
void DESCRIBE::Idle()
{
	glutPostRedisplay();
}

// fBXvCXg̍XV
void DESCRIBE::UpDateDisplayList(int Val)
{
	glNewList(COMMAND_DRAW_BODY,GL_COMPILE);	// glDrawBODY()R}hƂă[ɕۑ(ZNV̍)
	glDrawBODY();								// IGESf[^`
	glEndList();

	if(DrawUserFuncFlag == TRUE && Val == TRUE){	// UserFuncsς݂ȂUserFuncXg(UserFucnsς݂łAXgȂꍇValFALSE^)
		glNewList(COMMAND_DRAW_USER,GL_COMPILE);
		User.UserFuncMain(glbody,SelectedEntList,PickCount);
		glEndList();
	}
}

// `
void DESCRIBE::glDrawAxis(double Ascale,double Mscale)
{
	double AxisPos = Ascale/Mscale;
	double CharPos = (Ascale+0.1)/Mscale;

	glDisable(GL_LIGHTING);

	glLineWidth(1);
	glBegin(GL_LINES);
	//draw Xaxis@
	glColor3f(1.0, 0.0, 0.0);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(AxisPos, 0.0, 0.0);

	//draw Yaxis@
	glColor3f(0.0, 1.0, 0.0 );
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(0.0, AxisPos, 0.0);

	//draw Zaxis@
	glColor3f(0.0, 0.0, 1.0);
	glVertex3d(0.0, 0.0, 0.0);
	glVertex3d(0.0, 0.0, AxisPos);
	glEnd();

	/* Draw Xcone */
	glColor3f(1.0, 0.0, 0.0);
	glPushMatrix();
	glTranslatef(AxisPos, 0.0, 0.0);
	glRotatef(90.0, 0.0, 1.0, 0.0);
	glutSolidCone(AxisPos*0.1,AxisPos*0.5,4.0,1.0);
	glPopMatrix();

	/* Draw Ycone */
	glColor3f(0.0, 1.0, 0.0);
	glPushMatrix();
	glTranslatef(0.0, AxisPos, 0.0);
	glRotatef(-90.0, 1.0, 0.0, 0.0);
	glutSolidCone(AxisPos*0.1,AxisPos*0.5,4.0,1.0);
	glPopMatrix();

	/* Draw Zcone */
	glColor3f(0.0, 0.0, 1.0);
	glPushMatrix();
	glTranslatef(0.0, 0.0, AxisPos);
	glutSolidCone(AxisPos*0.1,AxisPos*0.5,4.0,1.0);
	glPopMatrix();

	//  X
	glColor3d(1.0,0.0,0.0);
	glRasterPos3d(CharPos,0.0,0.0);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10,'X');

	//  Y
	glColor3d(0.0,1.0,0.0);
	glRasterPos3d(0.0,CharPos,0.0);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10,'Y');

	//  Z
	glColor3d(0.0,0.0,1.0);
	glRasterPos3d(0.0,0.0,CharPos);
	glutBitmapCharacter(GLUT_BITMAP_HELVETICA_10,'Z');

	glEnable(GL_LIGHTING);
}

// o[oh`
void DESCRIBE::glDrawRubberband(double sx,double sy,double ex,double ey)
{
	glDisable(GL_LIGHTING);
	glLineWidth(1);
	glLineStipple(1, 0xE0E0);
	glColor3f(0.2, 0.9, 0.9);
	glEnable(GL_LINE_STIPPLE);
	glBegin(GL_LINE_STRIP);
	glVertex2d(sx,sy);
	glVertex2d(ex,sy);
	glVertex2d(ex,ey);
	glVertex2d(sx,ey);
	glVertex2d(sx,sy);
	glEnd();
	glDisable(GL_LINE_STIPPLE);
	glEnable(GL_LIGHTING);
}

// o[Wo
void DESCRIBE::VersionInfo()
{
	fprintf(stderr,"KODATUNO R1.0\n");
}
