#ifndef _NURBS_FUNC_H_
#define _NURBS_FUNC_H_

#include "BODY.h"
#include "Describe_BODY.h"

#define INTERSECPTNUMMAX	1000			// _i[z
#define NEAREST_GAP			0.01			// 2__Ƃ݂Ȃ
#define CONVERG_GAP			0.000001		// j[g@̎𔻕ʂ臒l
#define LOOPCOUNTMAX		100				// vZ񐔂̏

// NURBS̑W߂NX`
class NURBS_Func
{
public:
	Coord CalcNurbsCCoord(NURBSC *,double);						// w肵mbgtłNURBSȐ̍Wl߂
	Coord CalcNurbsSCoord(NURBSS *,double,double);				// w肵mbgu,vłNURBSȖʂ̍W_߂
	Coord CalcDiffuNurbsS(NURBSS *,double,double);				// w肵mbgu,vłNURBSȐu1KW߂
	Coord CalcDiffvNurbsS(NURBSS *,double,double);				// NURBSȐv1KW߂
	int GenNurbsC(NURBSC *,int,int,int,double [],double [],Coord []);	// 1NURBSȐ𐶐
	int GenNurbsC(NURBSC *,NURBSC);								// 1NURBSȐ𐶐(NURBSȐ̃Rs[)(I[o[[h)
	void DelNurbsC(NURBSC *);									// NURBSȐ폜
	int GenNurbsS(NURBSS *,NURBSS);								// 1NURBSȖʂ𐶐(NURBSȖʂ̃Rs[)
	void DelNurbsS(NURBSS *);									// NURBSȖʂ폜
	int GenTrimdNurbsS(TRIMD_NURBSS *,TRIMD_NURBSS);			// gʂ𐶐
	int DelTrimdNurbsS(TRIMD_NURBSS *);							// gʂ폜([)
	double CalcBSbasis(double,double [],int,int);				// BXvC֐vZAvZʂԂ
	double CalcDiffBSbasis(double,double [],int,int);			// BXvC֐1KW߂
	Coord CalcDiffNurbsC(NURBSC *,double);						// NURBSȐ1KW߂
	Coord CalcNormVecOnNurbsS(NURBSS *,double,double);			// NURBSȖʏ(u,v)ɂ@xNgƂ߂
	int CalcIntersecCurve3(NURBSC *,Coord,Coord,double *,int);	// 3ȉNURBSȐƕʂƂ̌_߂
	int CalcIntersecPtsPlaneV3(NURBSS *,Coord,Coord,int,Coord *,int);	// 3ȉNURBSȖʂƕʂƂ̌_Q㐔vZŋ߂(vp[^)
	int CalcIntersecPtsPlaneU3(NURBSS *,Coord,Coord,int,Coord *,int);	// 3ȉNURBSȖʂƕʂƂ̌_Q㐔vZŋ߂(up[^)
	int CalcIntersecPtsPlaneSearch3(NURBSS *,Coord,Coord,double,Coord *,int);	// 3ȉNURBSȖʂƕʂƂ̌_QǐՖ@ŋ߂
	int GetBSplCoef3(int,int,int,double *,double **);			// 3BXvCȐ̊eW߂@(at^3 + bt^2 + ct + ďWa,b,c,dԂ)
	int GetBSplCoef2(int,int,int,double *,double **);			// 2BXvCȐ̊eW߂@(at^2 + bt + čWa,b,cԂ)
	int GetBSplCoef1(int,int,int,double *,double **);			// 1BXvCȐ̊eW߂@(at + b̌Wa,bԂ)
	void ShiftNurbsS(NURBSS *,Coord);							// NURBSȖʂ̃Vtg
	void ShiftNurbsC(NURBSC *,Coord);							// NURBSȐ̃Vtg
	void ChRatioNurbsS(NURBSS *,Coord);							// NURBSȖʂ̔{ύX
	void ChRatioNurbsC(NURBSC *,Coord);							// NURBSȐ̔{ύX
	int SetCPNurbsS(NURBSS *,NURBSS);							// Rg[|Cg

private:
	int GetNurbsCCoef(NURBSC *,double **,int,Coord *,double *);	// NURBSȐ̌W߂(ō3)
	int CalcEquation(double *,double *,int);					// 3܂ł𔻕ʂĉ
	void GetNurbsSCoef(int,double **,double *,Coord *,int,Coord *,double *);	// NURBSȖʂɂu܂vŒ肵ꍇɓNURBSȐC(u) or C(v)̕ꕪq̌W߂
	void GetIntersecEquation(int,Coord *,double *,Coord,Coord,double *);		// NURBSȐƕʂ̌op3𓾂
};

#endif
