#ifndef _STDAFX_H_
#define _STDAFX_H_

// R[obNɊւWindowsUNIX̌݊ۂ}N(Ԃ)
#ifdef _MSC_VER
#ifndef CALLBACK
#define CALLBACK __stdcall
#endif
#define EXPORT extern "C" __declspec(dllexport)
#else
#ifndef CALLBACK
#define	CALLBACK
#endif
#define EXPORT extern "C"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <GL/glut.h>

#define ERR		-1					// ŨV{
#define FALSE	1					// ŨV{
#define TRUE	0					// ^̃V{
#define PI 3.141592653589793		// ~
#define APPROX_ZERO	1.0e-8			// [ƌȂl

typedef double **Matrix;	// double`2zMatrixƂĒ`
typedef double *Vector;		// double`1zVectorƂĒ`

// Wp\̂`
typedef struct{
	double x,y,z;
}Coord;

// \p\
typedef struct{
	float Color[4];	// F(r,g,b,?)
	// \̒ǉ͂ɋLq
}DispStat;


// O[oȊ֐̒` ///////////////////////////////////////////////////////////////////////////

// ,3xNg,s񉉎Z
void InitCoord(Coord *);			// Wl̏
Coord AddCoord(Coord,Coord);		// Wl̑Z
Coord AddCoord(Coord,double);		// I[o[[h
Coord DivCoord(Coord,Coord);		// Wl̊Z
Coord DivCoord(Coord,double);		// I[o[[h
Coord MulCoord(Coord,Coord);		// Wl̊|Z(xNg̓,Oςł͂Ȃ̂Œ)
Coord MulCoord(Coord,double);		// I[o[[h
Coord SubCoord(Coord,Coord);		// Wl̈Z
Coord SubCoord(Coord,double);		// I[o[[h
Coord SetCoord(Coord);					// Wl
Coord SetCoord(double,double,double);	// I[o[[h
int DiffCoord(Coord,Coord);			// WlȂTRUEAقȂĂȂFALSEԂ
void InitVector(Vector,int);		// 1z̏(:xNg,z)
void InitMatrix(Matrix,int,int);	// 2z̏
Coord NormalizeVec(Coord);			// 3xNg𐳋K
double CalcEuclid(Coord);			// [NbhƂ߂
double CalcEuclidPnts2D(Coord,Coord);	// 2Wł2_Ԃ̃[NbhZo
double CalcEuclidPnts3D(Coord,Coord);	// 3Wł2_Ԃ̃[NbhZo
double CalcInnerProduct(Coord,Coord);	// ς߂
Coord CalcOuterProduct(Coord,Coord);	// Oς߂
double CalcScalarTriProduct(Coord,Coord,Coord);	// XJ[Odς߂
double CalcinnerProduct(Coord,double,double,double);	// I[o[[h
double DegToRad(double degree);			// pxPʂdegreeradian
double RadToDeg(double radian);			// pxPʂradiandegree
Coord Arc_CP(Coord,Coord,double);		// ~̒S_(vec[0])~ɐڂCӂ2{̐ڐ_ւ̃xNg(Sp0<<)
double Rot_Vec_Ang(Coord,Coord);		// Cӂ̃xNg]Ƃ̉]p߂(2D)
Coord Rot_Vec(Coord,double);			// Cӂ̃xNg]xNg߂(2D)
Coord NormalVector(Coord,Coord);		// Ȗʂu,v̐ڐxNg@xNg߂
bool IsPointInPolygon(Coord,Coord *,int);	// ړ_̑p`O
void MulMxMx(Matrix,int,int,Matrix,int,int,Matrix);	// s񓯎m̊|Z
void MulMxVec(Matrix,int,int,Vector,int,Vector);	// sƃxNg̊|Z
Coord HomoTransform(double[][3],double[],Coord);	// ϊ(]+iړ)

// lvZ
double sgn(double);						// 
void BubbleSort(int[],int);				// ou\[g({@)
void BubbleSort(double[],int);			// I[o[[h
int QCmp(const void *,const void *);	// NCbN\[g 
int CalcCubicEquation(double *,double *);		// 3̉߂
int CalcQuadraticEquation(double *,double *);	// 2̉߂
int CalcLinearEquation(double *,double *);		// 1̉߂

// `֘A
void DrawPoint(Coord,double,double,double []);			// _`
void DrawVector(Coord,Coord,double,double,double []);	// xNg`

// [֘A
Matrix NewMatrix(int,int);			// 2double^z̃[m
void FreeMatrix(Matrix);			// 2double^z̃[
Coord **NewCoord(int,int);			// 2Coord^z̃[m
void FreeCoord(Coord **);			// 2Coord^z̃[



#endif
